#include "node/leg/state.h"

#pragma once

namespace schpin
{

class leg_view
{
        const leg_model& model_;
        const leg_state& state_;

      public:
        leg_view( const leg_model& m, const leg_state& s )
          : model_( m )
          , state_( s )
        {
        }

        const leg_model* operator->() const
        {
                return &model_;
        }

        const dof_array< em::angle >& get_angles() const
        {
                return state_.angles;
        }

        point< 3, robot_frame > get_tip_position() const
        {
                return model_.get_tip_position( state_.angles );
        }

        em::either< dof_array< em::angle >, ik_error >
        get_angles( const point< 3, robot_frame >& target, std::size_t stop_steps = 32 ) const
        {
                return model_.get_angles( target, state_.angles, stop_steps );
        }
};

}  // namespace schpin
