#include "shared/protocol.h"
#include "node/robot/model.h"
#include "node/state_machines/base.h"

#pragma once

namespace schpin
{

struct state_machine_i
{
        virtual opt_error< state_machine_error > on_cmd( fw_node_group_variant,
                                                         const node_context&,
                                                         sm_feedback_f )                    = 0;
        virtual opt_error< state_machine_error > tick( const node_context&, sm_feedback_f ) = 0;
        virtual bool                             finished()                                 = 0;
        virtual ~state_machine_i() = default;
};

}  // namespace schpin
