#include <emlabcpp/quantity.h>

#pragma once

namespace em = emlabcpp;

namespace schpin
{

template < typename Tag, typename T, T Offset >
class protocol_offset : public em::quantity< protocol_offset< Tag, T, Offset >, T >
{
      public:
        static constexpr T offset = Offset;
        using em::quantity< protocol_offset< Tag, T, Offset >, T >::quantity;
};

}  // namespace schpin

template < typename Tag, typename T, T Offset >
struct std::numeric_limits< schpin::protocol_offset< Tag, T, Offset > >
  : std::numeric_limits< emlabcpp::quantity< schpin::protocol_offset< Tag, T, Offset >, T > >
{
};
