#include "schpin_lib/geom/quaternion.h"

#include <gtest/gtest.h>

using namespace schpin;

TEST( Quaternion, global_constants )
{
        quaternion< world_frame > v{0, 0, 0, 1.f};
        EXPECT_EQ( neutral_quat, v );
}

TEST( Quaternion, rotation )
{
        point< 3, world_frame > p{1.f, 0.f, 0.f};

        auto res_p = rotate( p, quaternion< world_frame >( y_axis, em::pi / 4.f ) );
        point< 3, world_frame > desired{0.70710678118f, 0, -0.70710678118f};
        EXPECT_TRUE( almost_equal( res_p, desired ) );
}
