#include "schpin_lib/geom/point/serialization.h"
#include "schpin_lib/geom/simplex.h"

#include <gtest/gtest.h>

using namespace schpin;

TEST( SimplexTest, volume2d )
{
        std::array< point< 2, world_frame >, 3 > data{ point< 2, world_frame >( 0, 1 ),
                                                       point< 2, world_frame >( 1, 0 ),
                                                       point< 2, world_frame >( 0, 0 ) };

        simplex< point< 2, world_frame >, 2 > sim( data );

        ASSERT_EQ( volume_of( sim ), 0.5f );
}
TEST( SimplexTest, volume3d )
{
        std::array< point< 3, world_frame >, 4 > data{ point< 3, world_frame >( 0, 0, 1 ),
                                                       point< 3, world_frame >( 1, 0, 0 ),
                                                       point< 3, world_frame >( 0, 0, 0 ),
                                                       point< 3, world_frame >{ 0, 1, 0 } };

        simplex< point< 3, world_frame >, 3 > sim( data );

        ASSERT_NEAR( volume_of( sim ), 0.166667f, 0.00001f );
}

TEST( SimplexTest, json )
{
        std::array< point< 3, world_frame >, 4 > data{ point< 3, world_frame >( 0, 0, 1 ),
                                                       point< 3, world_frame >( 1, 0, 0 ),
                                                       point< 3, world_frame >( 0, 0, 0 ),
                                                       point< 3, world_frame >{ 0, 1, 0 } };

        using simplex_type = simplex< point< 3, world_frame >, 3 >;

        simplex_type sim( data );

        nlohmann::json simplex_j = nlohmann::json( sim );
        ASSERT_EQ( simplex_j.get< simplex_type >(), sim ) << simplex_j;
}
