#include "body.h"

#pragma once

namespace schpin
{

struct body_state
{
        pose< world_frame > pos;
};

inline std::ostream& operator<<( std::ostream& os, const body_state& bs )
{
        return os << bs.pos;
}

class body_state_view
{

        const body_state state_;
        const body&      body_;

      public:
        body_state_view( const body& body, const body_state& state )
          : state_( state )
          , body_( body )
        {
        }

        const body& get_body() const
        {
                return body_;
        }

        const pose< world_frame >& get_pose() const
        {
                return state_.pos;
        }

        template < collision_mode Mode >
        oc_node_collision_query< Mode, occupancy_content, world_frame, robot_frame >
        get_query() const
        {
                return oc_node_collision_query< Mode, occupancy_content, world_frame, robot_frame >{
                    body_.get_collision_tree().get_proxy_root(), state_.pos };
        }
};

}  // namespace schpin
