#include <filesystem>
#include <schpin_lib_exp/config.h>
#include <string>

#pragma once

namespace schpin
{
struct reactor_config
{
        std::string                            robot_description_topic = "/robot_description";
        std::string                            robot_semantics_topic   = "/robot_semantics";
        std::filesystem::path                  cache_prefix            = "~/.schpin/cache";
        std::optional< std::filesystem::path > lua_boot_script;

        static auto ros_param_get()
        {
                return std::make_tuple(            //
                    ros_opt_param< std::string >(  //
                        "robot_description_topic",
                        "Topic from which the planner should read robot description",
                        "/robot_description" ),
                    ros_opt_param< std::string >(  //
                        "robot_semantics_topic",
                        "TOpic from which the semantic description of robot should be read",
                        "/robot_semantics" ),
                    ros_opt_param< std::filesystem::path >(  //
                        "cache_path",
                        "path to cache for robot termporary data",
                        "~/.schpin/cache" ),
                    ros_param< std::optional< std::filesystem::path > >(  //
                        "lua_boot_script",
                        "lua script to be executed at start of the motion planner" ) );
        }
};
}  // namespace schpin
