#include <sstream>

#pragma once

namespace schpin
{

template < typename Graph >
std::string graphToDot( const Graph& g )
{

        std::stringstream ss;

        ss << "digraph G{" << std::endl;

        for ( const auto& vertex : g.getVertexes() ) {
                for ( const auto& edge : vertex.getEdges() ) {
                        ss << edge.getSourceID() << " ->  " << edge.getTargetID() << ";"
                           << std::endl;
                }
        }

        ss << "}";

        return ss.str();
}

}  // namespace schpin
