#include "events.h"
#include "planner/base.h"

#include <experimental/propagate_const>
#include <schpin_lib/lua/base.h>
#include <variant>

#pragma once

namespace schpin
{

using lua_event_var = std::variant< load_environment_event,
                                    set_goal_pose_event,
                                    set_current_pose_event,
                                    plan_event,
                                    clear_event,
                                    export_event,
                                    show_body_collision_event,
                                    show_leg_graph_event,
                                    show_workarea_event,
                                    print_model_event,
                                    print_pose_cache_event,
                                    make_vertexes_event,
                                    find_body_path_event,
                                    make_until_path_event,
                                    export_path_event,
                                    quit_event >;

class lua_vm_eventmaker
{
        struct impl;
        std::experimental::propagate_const< std::unique_ptr< impl > > impl_ptr_;

      public:
        lua_vm_eventmaker();

        bool                              is_finished();
        opt_error< slua_error >           load_file( std::filesystem::path );
        em::either< lua_res, slua_error > tick( std::function< void( lua_event_var ) > );

        ~lua_vm_eventmaker();
};

}  // namespace schpin
