#include "leg.h"
#include "leg/graph/gen.h"
#include "leg/graph/space.h"
#include "schpin_test/leg_test_util.h"

#include <gtest/gtest.h>

using namespace schpin;

TEST( Collision, SimplexTrianglesGraph )
{
        leg_graph< 2 > graph = gen_leg_test_graph< 2 >( 3 );

        simplex< leg_vertex_id, 2 > s1{leg_vertex_id{1}, leg_vertex_id{3}, leg_vertex_id{4}};
        simplex< leg_vertex_id, 2 > s2{leg_vertex_id{1}, leg_vertex_id{2}, leg_vertex_id{4}};

        simplex_graph_collision_query< 2 > q1( graph, s1 );
        simplex_graph_collision_query< 2 > q2( graph, s2 );

        EXPECT_FALSE( collides< 2 >( q1, q2 ) )
            << draw_simplexes( graph, std::vector< simplex< leg_vertex_id, 2 > >{s1, s2} );
}
