#include <chrono>
#include <ctime>
#include <ros/ros.h>
#include <rosgraph_msgs/Log.h>
#include <schpin_lib/print.h>

using namespace schpin;

void on_message( const rosgraph_msgs::LogConstPtr& msg )
{
        term_color msg_color = term_color::RESET;
        switch ( msg->level ) {
                case rosgraph_msgs::Log::FATAL:
                case rosgraph_msgs::Log::WARN:
                case rosgraph_msgs::Log::ERROR:
                        msg_color = term_color::RED;
                        break;
                case rosgraph_msgs::Log::DEBUG:
                        msg_color = term_color::YELLOW;
                        break;
                default:
                        break;
        }
        std::time_t scnds = static_cast< long >( msg->header.stamp.toSec() );
        std::tm     tmv   = *std::localtime( &scnds );
        std::cout << term_color::CYAN << std::put_time( &tmv, "%H:%M:%S" ) << "  "
                  << term_color::MAGENTA << msg->name << "  " << msg_color << msg->msg
                  << term_color::RESET << std::endl;

        //<< msg->file << msg->function << msg->line << std::endl;
}

int main( int argc, char* argv[] )
{
        ros::init( argc, argv, "stdout_logger" );

        ros::NodeHandle handle;

        auto subscriber = handle.subscribe( "/rosout_agg", 100, &on_message );

        ros::spin();

        return 0;
}
